package cz.muni.fi.pb112.constants;

/**
 * V tomto deme si vysvetlíme čo sú konštanty a ako ich vieme využiť v Jave
 *
 * Konštanty slúžia na pomenovanie určitých konkrétnych hodnôt, ktoré chceme použiť v programe
 * Keďže, napríklad číselné konštanty, sú sami o sebe málo popisné, vytvoríme pre ne identifikátor, ktorý používame namiesto hodnoty
 * Konštantou môže byť aj objekt
 * Definujú sa kľúčovím slovom final
 */
public class Demo {
    // kľúčové slovo static nájdete podrobnejšie vysvetlené v balíku static
    // všetky konštantné atribúty budú aj statické
    // konštanta môže byť aj private ak máme záujem ju použiť len v rámci jednej triedy, obvykle však býva public
    public final static int ANSWER_TO_EVERYTHING = 42;

    public static void main(String[] args) {
        // konštantu vieme používať ako bežnú premennú
        System.out.println("Answer to everything is: " + ANSWER_TO_EVERYTHING);

        // nevieme do nej priradiť inú hodnotu
        //ANSWER_TO_EVERYTHING = 0; // compilation error

        // konštantou môže byť aj objekt
        final Person Peter = new Person("Peter", 18);

        // do premennej nie je možne priradiť odkaz na nový objekt
        //Peter = new Person("Mike", 13); // compilation error

        // avšak objekt samotný je možné zmeniť
        Peter.setName("Pete");
    }
}
