package cz.muni.fi.pb112.enums;

/**
 * V tomto deme si vysvetlíme čo je enum a ukážeme príklady jeho bežného použitia
 *
 * Je to spôsob reprezentácie konečnej množiny konštánt, napríklad (dni v týždni, planéty slnečnej sústavy,...)
 * Je typovo bezpečný
 * Premenná daného výčtového typu musí nabrať jednu z vymenovaných hodnôt
 * Enum je definovaný pomocou kľúčového slova enum
 * Enum Month v tomto balíčku je príkladom jednoduchého enumu
 * Každý nami zadefinovaný enum je potomkom triedy java.lang.Enum
 */
public class Demo {
    // premenná typu enum môže byť použitá ako atribút
    private Month month;

    public static void main(String[] args) {
        // Premennú naplníme pomocou názovu enumu a vybranej hodnoty
        Month coldMonth = Month.JANUARY;
        // Keďže je premenná typu Month objektového typu môže byť null
        coldMonth = null;

        System.out.println("How does uni student see weather during winter holiday:");
        tellWeather(Month.DECEMBER);
        System.out.println("Summer holiday:");
        tellWeather(Month.JULY);
        System.out.println("Rest of the year:");
        tellWeather(Month.APRIL);

        // každý prvok enumu má svoju číselnú hodnotu
        // vieme ju získať napríklad pomocou zdedenej metódy ordinal()
        System.out.println("Number value of January is: " + Month.JANUARY.ordinal());

    }

    public static void tellWeather(Month month) {
        // typické využitie enumu je napríklad vo vetvení switch
        switch (month) {
            case DECEMBER:
                System.out.println("Its snowing!");
                break;
            case JANUARY:
                System.out.println("I am gonna freeze to death!");
                break;
            case JULY:
                System.out.println("That is some fine holiday weather.");
                break;
            case AUGUST:
                System.out.println("Why are we boiling alive?");
                break;
            default:
                System.out.println("What does sunlight look like?");
        }
    }

}
