package cz.muni.fi.pb112.immutable;

/**
 * V tomto deme si vysvetlíme čo sú immutable objekty a predstavíme si jednú zo základných immutable java tried - String
 *
 * Immutable objekty sú objekty, ktoré po ich vytvorení nie je možne zmeniť
 * Bezpečne vieme čo sa v ňom nachádza v akejkoľvek situácii
 * Je možné ho používať z viacerých miest súčasne, bez toho aby hrozili nekonzistencie (napr. z viacerých vlákien)
 * Vhodné pre objekty, u ktorých dochádza k zmenám len veľmi zriedkavo
 */
public class Demo {
    public static void main(String[] args) {
        // jednoduchý príklad vytvorenej immutable triedy je trieda mountain v tomto balíku
        Mountain everest = new Mountain("Mt. Everest", 8848);

        // po vytvorení objektu ho už nie je možne zmeniť
        // priami prístup k atribútu nie je možný kvôli privátnym atribútom
        //everest.name = "Big mountain"; // compilation error

        // v triede nie sú prítomné settre
        // everest.setName("Sagarmáthá") // compilation error

        // ak chceme zmeniť objekt v premennej musíme vytvoriť nový
        everest = new Mountain("Sagarmáthá", 8848);
    }
}
