package cz.muni.fi.pb112.keywordstatic;

/**
 * Trieda reprezentuje vytlačený pokladničný blok
 * Blok je vytlačený v momente keď vznikne nový objekt typu Bill alebo keď na blok bola pridaná ďalšia položka a musí sa vytlačiť nanovo
 */
public class Bill {
    private String items;
    private double price;

    // attribút totalCount je zdieľaný pre všetky inštancie triedy Bill
    private static int totalCount;

    public Bill(String items, double price) {
        this.items = items;
        this.price = price;
        totalCount++;
    }

    public void addItem(String item, double price) {
        items = items + ", " + item;
        this.price += price;
        // k statickému atribútu je možne pristupovať aj v nestatickej metóde
        totalCount++;
    }

    public static int getTotalCount() {
        return totalCount;
    }

    public static void addMilk() {
        // zo statickej metody neviem volať nestatické metódy
        // riešením by bolo urobiť túto triedu nestatickú
        // addItem("milk", 1.19);

        // rovnako neviem pristupovat k nestatickým attribútom
        // this.items += ", milk";
        // this.price += 1.19;
    }


}
