package cz.muni.fi.pb112.keywordstatic;

/**
 * Kľúčové slovo static pri metóde alebo attribúte spôsobí to, že daná metóda alebo atribút patrí celej triede nie
 * konkrétnej inštancii
 * Statické metódy alebo atribúty vieme použiť v nestatických metódach
 * Nestatické metódy a atribúty neviem použiť v statickej metóde
 * Bill je príkladom triedy so statickými atribútmi a metódami
 */
public class Demo {
    public static void main(String[] args) {
        Bill bill = new Bill("eggs, water, toilet paper", 5.47);

        // k statickej metóde vieme pristúpiť pomocou názvu triedy, nepotrebujeme inštanciu
        System.out.println("Total number of printed bills: " + Bill.getTotalCount()); // 1

        Bill toyStoreBill = new Bill("Lego", 29.99);

        // k statickej metóde vieme pristúpiť aj pomocou inštancie triedy
        System.out.println("Total number of printed bills: " + toyStoreBill.getTotalCount()); // 2

        // statický attribút je zdieľaný, nezáleži z ktorej inštancie zavoláme metódu getTotalCount()
        System.out.println("Total count form different instance: " + bill.getTotalCount()); // 2

    }
}
