package cz.muni.fi.pb112.overloading;

/**
 * Preťažovanie(overloading) metód dovoľuje aby v jednej triede existovalo viacero metód, ktoré majú rovnaký názov
 * Je možné preťažovať aj konštruktory(detailnejšie ukázané vo vzorových kódoch pre druhý týždeň)
 * Aby mohlo existovať viacero metód s rovnakým názvom je nutné aby sa rozlišovali počtom alebo typom argumentov
 * Zmena návratového typu nie je postačujúca
 * Ukážkovou triedou s preťaženými metódami je trieda Singer
 */
public class Demo {
    public static void main(String[] args) {
        Singer fredy = new Singer("Fredy Mercury", "rock");
        Song weWillRockYou = new Song("We will rock you", "Buddy, you're a young man, hard man\n" +
                "Shouting in the street, gonna take on the world someday\n" +
                "You got blood on your face, you big disgrace\n" +
                "Waving your banner all over the place");
        // použitie metódy bez parametrov
        fredy.Sing();

        // použitie metódy s parametrom typu String
        fredy.Sing("Buddy, you're a boy, make a big noise\n" +
                "Playing in the street, gonna be a big man someday\n" +
                "You got mud on your face, you big disgrace\n" +
                "Kicking your can all over the place, singin'");

        // použitie metódy s dvoma parametrami
        fredy.Sing("We will, we will rock you", 2);

        // použitie metódy s parametrom typu Song
        fredy.Sing(weWillRockYou);

        /*
            V triede Singer si mozete povšimnúť zakomentovanú metódu Singer s parametrom String
            Narozdiel od druhej metody s rovnakým parametrom ma navratový typ String(nevypisuje priamo ale vracia text piesne)
            Ak by sme zavolali nasledujúci kód:
            String lyrics = fredy.Sing(weWillRockYou); kompilator by bol schopný rozhodnúť, ktorú metódu zavolať
            Avšak v jave je možné zanedbať návratový typ:
            fredy.Sing(weWillRockYou); // validný príkaz
            Preto preťažovanie len zmenou návratového typu nie je možné
         */
    }
}
