package cz.muni.fi.pb112.override;

/**
 * Prekrývanie(overriding) nám umožnuje upraviť implementáciu metód zdedených z nadtriedy
 * Dedičnosť bude vysvetlená neskôr, momentálne stačí vedieť, že ak podtrieda dedí z nadtriedy, získava všetky jej metódy a atribúty
 * K prekrytiu dochádza ak metóda v podtriede má rovnaký názov, parametre a návratový typ ako metóda v nadtriede
 * Prekryté metódy sa označújú anotáciou @Override
 * Trieda Object je nadtriedou pre všetky triedy
 * Trieda PersonWithOverride je ukážkovou triedou, ktorá využíva prekrytie
 */
public class Demo {
    public static void main(String[] args) {
        PersonWithOverride dave = new PersonWithOverride("Dave", 19);
        PersonWithoutOverride david = new PersonWithoutOverride("David", 22);

        // použije sa nami naimplementovanź metóda toString()
        System.out.println(dave);

        // použije sa metóda toString() z triedy Object
        // nami zadefinovaná metóda sa nepoužije z dôvodu chyby v názve metódy, nie chýbajúcej anotácie
        // v triede PersonWithoutOverride máme metódu pomenovanú toStrng() namiesto toString()
        // ak by sme použili anotáciu @Override, kompilátor by nás o tejto chybe varoval
        System.out.println(david);
    }
}
