package cz.muni.fi.pb112.string;

/**
 * V tomto deme si ukážeme najpoužívanejšie operácie s triedou String
 *
 * Trieda String sa nachádza v základnom java balíčku
 * Je príkladom immutable triedy
 * Zároveň je príkladom poľa(array) znakov, o poliach sa viac dozviete v nasledujúcich prednáškach
 */
public class Demo {
    public static void main(String[] args) {
        String greeting = "Hello World!";

        // na zistenie dlzky retazca sluzi metoda length()
        System.out.println("Length of string \"" + greeting + "\" is: " + greeting.length());

        // získať znak na špecifickej pozícii
        char firstCharacter = greeting.charAt(0);
        System.out.println("First character in String: \"" + greeting + "\" is \"" + firstCharacter + "\"");

        // na spojenie dvoch stringov je možné použiť metódu concat
        // dokáže však spojiť iba premenné typu string
        String extendedGreeting = greeting.concat(" Today I learn!");
        System.out.println(extendedGreeting);

        // na prevod znakov do uppercase vieme využit funkciu toUppercase()
        System.out.println("Shouting String \""+ greeting + "\" in uppercase: " + greeting.toUpperCase());

        // na prevod znakov do lowercase vieme využiť funkciu toLowercase()
        System.out.println("Whispering String \""+ greeting + "\" in lowercase: " + greeting.toLowerCase());

        // prázdnosť stringu vieme overiť pomocou metody isEmpty()
        System.out.println("String \""+ greeting + "\" is empty: " + greeting.isEmpty());
        String empty = "";
        System.out.println("String \"" + empty + "\" is empty: " + empty.isEmpty());

        // na overenie ci string obsahuje len "whitespace" môžeme použiť metódu isBlank()
        System.out.println("String \""+ greeting + "\" is blank: " + greeting.isBlank());
        String blank = "     ";
        System.out.println("String \""+ blank + "\" is blank: " + blank.isBlank());

        // na zistenie ci retazec obshauje nejaky podretazec mozeme vyuzit metodu contains()
        System.out.println("String \""+ greeting + "\" contains \"Ahoy\": " + greeting.contains("Ahoy"));
        String friends = "friendship";
        System.out.println("\"String \"" + friends + "\" contains \"ship\": " + friends.contains("ship"));

        // na overenie Stringu pomocou regexu môžeme použiť metódu matches
        System.out.println("String \""+ greeting + "\" matches \"\\w*\": " + greeting.matches("\\w*"));
        System.out.println("String \""+ greeting + "\" matches \"\\S* \\S*\": " + greeting.matches("\\S* \\S*"));

        // pre nahradu podreťazca v stringu za iný môžeme použiť metódu replace()
        // existuje viacero verzii metody replace (replaceAll, replaceFirst)
        System.out.println("Replace \"Hello\" in \"" + greeting + "\" with \"Aloha\": " + greeting.replace("Hello", "Aloha"));

        // pre rozdelenie retazca na jednotlive casti pomocou znaku alebo podretazca pouzijeme metodu split
        String shoppingList = "milk, butter, orange juice, donuts";
        String[] splitShoppingList = shoppingList.split(", ");
        System.out.println("My shopping list is:");
        for (int i = 0; i < splitShoppingList.length; i++) {
            System.out.println(i + ". " + splitShoppingList[i]);
        }
     }
}
